
; FASM SOURCE FILE
; http://flatassembler.net

; XviD (DivX) <BI>trate <C>alculator
; main project file

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

; ------------------------------------------------------------------------------

;            1024 * ( [target size (KB)] - [audio size (KB)] - [overhead (KB)] )
; bitrate  = -------------------------------------------------------------------
;                                  125 * [time (seconds)]
;
; overhead = (afactor * [audio track count] / iframes + ffactor) * [frame count]
; afactor  = audio overhead factor
; iframes  = audio interleave frame count
; ffactor  = frame overhead factor
;
; NB: factor values are experimental (look for <aof>, <fof> labels)

BIC:

; ------------------------------------------------------------------------------

  RS_Description EQU 'XviD (DivX) Bitrate Calculator'
  RS_Version     EQU '1.09.15'
  RS_Filename    EQU 'BIC.EXE'
  RS_Comments    EQU 'XviD (DivX) Bitrate Calculator'
  RS_Company     EQU '@L.CHEMIST GUILD'
  RS_Copyright   EQU '@L.CHEMIST'

  RS_WWW         EQU 'http://maalchemist.narod.ru'
  RS_Email       EQU 'maalchemist@gmail.com'

  ; WebMoney
  RS_WMR         EQU 'R388235483201'
  RS_WME         EQU 'E038486814864'
  RS_WMZ         EQU 'Z798041863268'

  ; Yandex.Money
  RS_YM          EQU '41001481909297'

; ------------------------------------------------------------------------------

  format PE GUI 4.0
  entry zentry

; ------------------------------------------------------------------------------

include 'WIN32A.INC'

include 'INCLUDE\SYSTEM.INC'
include 'INCLUDE\WINDOWS.INC'
include 'INCLUDE\FJXX.INC'

$.define DEBUG_CODE

include 'BIC.INC'

; ------------------------------------------------------------------------------

HTCAPTION         = 2
OBJ_BRUSH         = 2

WM_APP_POST_INIT  = WM_APP + 1
WM_APP_GETBITRATE = WM_APP + 2
WM_APP_SELECTFILE = WM_APP + 3

; custom combobox control messages
CBM_FIRST = 0x1700
CB_SETMINVISIBLE = CBM_FIRST + 1
CB_GETMINVISIBLE = CBM_FIRST + 2
CB_SETCUEBANNER  = CBM_FIRST + 3
CB_GETCUEBANNER  = CBM_FIRST + 4

; system menu items IDs
SMIID_SEPARATOR   = 40000
SMIID_XVID        = 40001
SMIID_DIVX        = 40002

; ------------------------------------------------------------------------------

section '.coda' code data readable writeable executable

zentry: invoke  GetModuleHandle, 0
        mov     [Instance], eax
        invoke  DialogBoxParam, eax, IDD_MAINDLG, HWND_DESKTOP, DialogProc, 0
        invoke  ExitProcess, 0

; ------------------------------------------------------------------------------

$proc DialogProc, hwnddlg, umsg, wparam, lparam

       $locals
       .mmi     MENUITEMINFO
       .control dd ?
;      .font    LOGFONT
       $end

    .enter:
        push    ebx esi edi

        mov     [.control], 0
    .umsg.switch:
        cmp     [umsg], WM_INITDIALOG
        je     .wm.initdialog
        cmp     [umsg], WM_CLOSE
        je     .wm.close
        cmp     [umsg], WM_COMMAND
        je     .wm.command
        cmp     [umsg], WM_SYSCOMMAND
        je     .wm.syscommand
        cmp     [umsg], WM_NCLBUTTONDBLCLK
        je     .wm.nclbuttondblclk
        cmp     [umsg], WM_CTLCOLORSTATIC
        je     .wm.ctlcolor.static
        cmp     [umsg], WM_APP_POST_INIT
        je     .wm.app.post.init
        cmp     [umsg], WM_APP_GETBITRATE
        je     .wm.app.getbitrate

        xor     eax, eax
        jmp    .return

    .wm.initdialog:
        mov     eax, [hwnddlg]
        mov     [Dialog], eax

        invoke  LoadIcon, [Instance], IDI_MAINICON
        invoke  SetClassLong, [hwnddlg], GCL_HICON, eax

        ; modify system menu
        invoke  GetSystemMenu, [hwnddlg], FALSE
        mov     [SysMenu], eax

        lea     esi, [.mmi]
        mov     [.mmi.cbSize], sizeof.MENUITEMINFO
        mov     [.mmi.fMask], MIIM_TYPE + MIIM_ID + MIIM_STATE

        mov     [.mmi.fType], MFT_SEPARATOR
        mov     [.mmi.fState], MFS_ENABLED
        mov     [.mmi.wID], SMIID_SEPARATOR
        invoke  InsertMenuItem, [SysMenu], SC_CLOSE, FALSE, esi

        mov     [.mmi.fType], MFT_STRING + MFT_RADIOCHECK

        mov     [.mmi.fState], MFS_ENABLED + MFS_UNCHECKED
        mov     [.mmi.wID], SMIID_DIVX
        mov     [.mmi.dwTypeData], sDIVX
        invoke  InsertMenuItem, [SysMenu], SMIID_SEPARATOR, FALSE, esi

        mov     [.mmi.fState], MFS_ENABLED + MFS_CHECKED
        mov     [.mmi.wID], SMIID_XVID
        mov     [.mmi.dwTypeData], sXVID
        invoke  InsertMenuItem, [SysMenu], SMIID_DIVX, FALSE, esi

        ; redraw system menu
        invoke  DrawMenuBar, [hwnddlg]

        ; get control`s handles
        mov     edi, controls - 6
        mov     ebx, controls.count
    .get.handle:
        lea     esi, [edi + ebx * 4]
        lea     esi, [esi + ebx * 2]
        movzx   eax, word [esi + 4]
        invoke  GetDlgItem, [hwnddlg], eax
        mov     [esi], eax
        dec     ebx
        jnz    .get.handle

        ; create bold font
;       invoke  SendMessage, [hwnddlg], WM_GETFONT, 0, 0
;       lea     edi, [.font]
;       invoke  GetObject, eax, sizeof.LOGFONT, edi
;       mov     [.font.lfWeight], FW_SEMIBOLD
;       invoke  CreateFontIndirect, edi
;       mov     [BoldFont], eax

        ; create bold font
        invoke  CreateFont, -11, 0, 0, 0, FW_SEMIBOLD, 0, 0, 0,\
                ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,\
                DEFAULT_PITCH + FF_DONTCARE, sTahoma
        mov     [BoldFont], eax

        ; assign bold font
        mov     edi, bold.controls - 6
        mov     ebx, bold.controls.count
    .set.font:
        lea     esi, [edi + ebx * 4]
        lea     esi, [esi + ebx * 2]
        invoke  SendMessage, [esi], WM_SETFONT, [BoldFont], 0
        dec     ebx
        jnz    .set.font

        ; fill cd size combo box
        mov     esi, cdsize
        stdcall fst2cb, [cb.cdsize], 0
        invoke  SetWindowText, [cb.cdsize], cdsize.D5D3

        ; fill size mul combo box
        mov     esi, cdsize.mul
        stdcall fst2cb, [cb.cdsize.mul], 0
        invoke  SetWindowText, [cb.cdsize.mul], cdsize.mul.01

        ; fill size div combo box
        mov     esi, cdsize.div
        stdcall fst2cb, [cb.cdsize.div], 0
        invoke  SetWindowText, [cb.cdsize.div], cdsize.div.01

        ; fill fps combo box
        mov     esi, fps
        stdcall fst2cb, [cb.fps], 0
        invoke  SetWindowText, [cb.fps], fps.25.000

        ; fill audio track count combo boxes
        mov     esi, atcount
        stdcall fst2cb, [cb.a1.tcount], [cb.a2.tcount]
        invoke  SetWindowText, [cb.a1.tcount], atcount.01
        invoke  SetWindowText, [cb.a2.tcount], atcount.00

        ; fill audio format combo boxes
        mov     esi, aformat
        stdcall fst2cb, [cb.a1.format], [cb.a2.format]
        invoke  SendMessage, [cb.a1.format], CB_SELECTSTRING, -1, aformat.ac3
        invoke  SendMessage, [cb.a2.format], CB_SELECTSTRING, -1, aformat.ac3

        ; fill audio bitrate combo boxes
        mov     esi, abitrate
        stdcall fst2cb, [cb.a1.bitrate], [cb.a2.bitrate]
        invoke  SetWindowText, [cb.a1.bitrate], abitrate.192
        invoke  SetWindowText, [cb.a2.bitrate], abitrate.192

        ; fill iframe combo box
        mov     esi, iframes
        stdcall fst2cb, [cb.a1.iframes], [cb.a2.iframes]
        invoke  SetWindowText, [cb.a1.iframes], iframes.01
        invoke  SetWindowText, [cb.a2.iframes], iframes.01

        invoke  CheckRadioButton, [hwnddlg], IDC_RB_FLENGTH, IDC_RB_FCOUNT, IDC_RB_FCOUNT
        invoke  CheckRadioButton, [hwnddlg], IDC_RB_A1_BITRATE, IDC_RB_A1_TSIZE, IDC_RB_A1_BITRATE
        invoke  CheckRadioButton, [hwnddlg], IDC_RB_A2_BITRATE, IDC_RB_A2_TSIZE, IDC_RB_A2_BITRATE

        ; unchecked by default for XVID mode
;       invoke  SendMessage, [ch.frover], BM_SETCHECK, BST_UNCHECKED, 0

        invoke  SetWindowLong, [ed.a1.tsize], GWL_WNDPROC, EditProc
        invoke  SetWindowLong, [ed.a2.tsize], GWL_WNDPROC, EditProc
        mov     [OrgEditProc], eax

        invoke  PostMessage, [hwnddlg], WM_APP_POST_INIT, 0, 0
        jmp    .return.0

    .wm.command:
        cmp     [wparam], BN_CLICKED shl 16 + IDC_BT_CLOSE
        je     .wm.close

        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_FLENGTH
        je     .clicked.video
        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_FCOUNT
        je     .clicked.video
        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_A1_BITRATE
        je     .clicked.audio1
        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_A1_TSIZE
        je     .clicked.audio1
        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_A2_BITRATE
        je     .clicked.audio2
        cmp     [wparam], BN_CLICKED shl 16 + IDC_RB_A2_TSIZE
        je     .clicked.audio2
        cmp     [wparam], BN_CLICKED shl 16 + IDC_CH_FROVER
        je     .clicked.frover

        cmp     word [wparam + 2], CBN_EDITCHANGE
        je     .cb.edit.change
        cmp     word [wparam + 2], CBN_SELCHANGE
        je     .cb.selection.change
        cmp     word [wparam + 2], EN_CHANGE
        je     .edit.change

        jmp    .return.0

    .cb.edit.change:
        mov     esi, [lparam]
        mov     [.control], esi
        jmp    .update.bitrate

    .cb.selection.change:
        mov     esi, [lparam]
        mov     [.control], esi
        jmp    .update.bitrate

    .edit.change:
        mov     esi, [lparam]
        cmp     esi, [LockEdit]
        je     .return.0
        invoke  GetFocus
        cmp     eax, esi
        jne    .return.0
        mov     [.control], esi

    .clicked.frover:

    .update.bitrate:
        invoke  PostMessage, [hwnddlg], WM_APP_GETBITRATE, [.control], 0
        jmp    .return.0

    .clicked.video:
        invoke  IsDlgButtonChecked, [hwnddlg], IDC_RB_FLENGTH
        mov     esi, eax
        invoke  EnableWindow, [ed.hours], esi
        invoke  EnableWindow, [ed.minutes], esi
        invoke  EnableWindow, [ed.seconds], esi
        dec     esi
        invoke  EnableWindow, [ed.fcount], esi
        jmp    .update.bitrate
;       jmp    .return.0

    .clicked.audio1:
        mov     ebx, a1.controls
        jmp    .clicked.audio

    .clicked.audio2:
        mov     ebx, a2.controls
;       jmp    .clicked.audio

    .clicked.audio:
        ; -> ebx - [audio controls array] offset
        ; ebx + 00 = audio track count COMBOBOX
        ; ebx + 06 = audio format COMBOBOX
        ; ebx + 12 = audio bitrate COMBOBOX
        ; ebx + 18 = audio track size EDIT
        ; ebx + 24 = audio track size RADIOBUTTON
        ; ebx + 28 = audio track size RADIOBUTTON IDC
        ; ebx + 30 = audio interleave frame count COMBOBOX
        ; ebx + 36 = audio interleave interval STATICTEXT
        movzx   eax, word [ebx + 28]
        invoke  IsDlgButtonChecked, [hwnddlg], eax
        mov     esi, eax
        invoke  EnableWindow, [ebx + 18], esi
        dec     esi
        invoke  EnableWindow, [ebx + 12], esi
        jmp    .return.0

    .wm.syscommand:
        cmp     [wparam], SMIID_XVID
        je     .xvid.mode
        cmp     [wparam], SMIID_DIVX
        je     .divx.mode
        jmp    .return.0

    .wm.nclbuttondblclk:
        cmp     [wparam], HTCAPTION
        jne    .return.0

    .toggle.mode:
        invoke  GetMenuState, [SysMenu], SMIID_XVID, MF_BYCOMMAND
        and     eax, MF_CHECKED
        jnz    .divx.mode
;       jmp    .xvid.mode

    .xvid.mode:
        fld     qword [sXVID]
        fstp    qword [sCAPTION]
        mov     esi, MF_BYCOMMAND + MF_CHECKED
        mov     edi, MF_BYCOMMAND + MF_UNCHECKED
        mov     ebx, BST_UNCHECKED
        jmp    .update.mode

    .divx.mode:
        fld     qword [sDIVX]
        fstp    qword [sCAPTION]
        mov     esi, MF_BYCOMMAND + MF_UNCHECKED
        mov     edi, MF_BYCOMMAND + MF_CHECKED
        mov     ebx, BST_CHECKED
;       jmp    .update.mode

    .update.mode:
        ; -> esi - XVID menu state
        ; -> edi - DIVX menu state
        ; -> ebx - frame overhead CHECKBOX state
        invoke  CheckMenuItem, [SysMenu], SMIID_XVID, esi
        invoke  CheckMenuItem, [SysMenu], SMIID_DIVX, edi
        invoke  PostMessage, [ch.frover], BM_SETCHECK, ebx, 0
        jmp    .update.bitrate

    .wm.ctlcolor.static:
        mov     eax, [ed.vbitrate]
        cmp     eax, [lparam]
        je     .wm.ctlcolor.ed.vbitrate
        mov     eax, [ed.cdsize]
        cmp     eax, [lparam]
        je     .wm.ctlcolor.ed.cdsize
        jmp    .return.0

    .wm.ctlcolor.ed.vbitrate:
        invoke  SetTextColor, [wparam], [BitrateColor]
        invoke  SetBkMode, [wparam], TRANSPARENT
        invoke  GetSysColorBrush, COLOR_BTNFACE
        jmp    .return

    .wm.ctlcolor.ed.cdsize:
        invoke  SetTextColor, [wparam], [CDSizeColor]
        invoke  SetBkMode, [wparam], TRANSPARENT
        invoke  GetSysColorBrush, COLOR_BTNFACE
        jmp    .return

    .wm.app.post.init:
        mov     esi, [ed.fcount]
        invoke  SetFocus, esi
        invoke  PostMessage, esi, EM_SETSEL, 6, 6
        jmp    .update.bitrate

    .wm.app.getbitrate:
        invoke  SetWindowText, [hwnddlg], sCAPTION
        stdcall GetBitrate, [wparam]
        jmp    .return.0

    .wm.close:
;       invoke  DeleteObject, [BoldFont]
        invoke  EndDialog, [hwnddlg], 0

    .return.0:
        xor     eax, eax
    .return:
        pop     edi esi ebx
        ret
$endp

; ------------------------------------------------------------------------------

$proc EditProc, hwnd, umsg, wparam, lparam

        cmp     [umsg], WM_LBUTTONDBLCLK
        je     .ep.dblclk
        cmp     [umsg], WM_MBUTTONUP
        je     .ep.mbuttonup
        cmp     [umsg], WM_APP_SELECTFILE
        je     .ep.selectfile
        jmp    .ep.return

    .ep.dblclk:
        invoke  GetKeyState, VK_CONTROL
        and     ax, 0x8000
        test    ah, ah
        je     .ep.return
    .ep.mbuttonup:
        invoke  SetFocus, [hwnd]
        invoke  PostMessage, [hwnd], WM_APP_SELECTFILE, 0, 0
        jmp    .ep.return

    .ep.selectfile:
        stdcall SelectFile, [hwnd]

    .ep.return:
        invoke  CallWindowProc, [OrgEditProc], [hwnd], [umsg], [wparam], [lparam]
        ret
$endp

; ------------------------------------------------------------------------------

$proc GetBitrate, control

       $locals
       .bsize   = 64
       .buffer  rb .bsize

       .cdsize  dq ? ; size of destination cd
       .sizem   dq ? ; size multiplier
       .sized   dq ? ; size divider
       .fps     dq ?
       .hours   dq ?
       .mins    dq ?
       .secs    dq ?
       .delta1  dq ? ; [audio 1] size + [audio overhead 1]
       .delta2  dq ? ; [audio 2] size + [audio overhead 2]
       .frover  dq ? ; frame overhead

       .fcount  dq ? ; frame count
       .ftimes  dq ? ; film length in seconds

       .tsize   dq ? ; track size in KB
       .abrate  dq ? ; audio bitrate
       .aformat dd ? ; audio format
       .tcount  dd ? ; track count

       .iframes dd ? ; interleave frame count
       $end

    .gb.enter:
        push    ebx esi edi
        lea     esi, [.buffer]
        fpu.init

        mov     eax, [control]
        cmp     eax, [cb.cdsize]
        je     .gb.size.control.combobox
        cmp     eax, [cb.cdsize.mul]
        je     .gb.size.control.combobox
        cmp     eax, [cb.cdsize.div]
        je     .gb.size.control.combobox
        cmp     eax, [ed.cdsize]
        je     .gb.size.control.edit
        jmp    .gb.size.control.leave
    .gb.size.control.combobox:
        mov     [SizeEdit], 0
        jmp    .gb.size.control.leave
    .gb.size.control.edit:
        mov     [SizeEdit], 1
    .gb.size.control.leave:

    .gb.cdsize:
        cmp     [SizeEdit], 1
        je     .gb.cdsize.edit
    .gb.cdsize.combobox:
        ; get target CD size
        mov     eax, [cb.cdsize]
        lea     edi, [.cdsize]
        call    wt2f64
        ; get size multiplier
        mov     eax, [cb.cdsize.mul]
        lea     edi, [.sizem]
        call    wt2f64
        ; get size divider
        mov     eax, [cb.cdsize.div]
        lea     edi, [.sized]
        call    wt2f64
        jmp    .gb.cdsize.leave
    .gb.cdsize.edit:
        ; get target CD size
        mov     eax, [ed.cdsize]
        lea     edi, [.cdsize]
        call    wt2f64
    .gb.cdsize.leave:

    .gb.flength:
        ; get target fps
        mov     eax, [cb.fps]
        lea     edi, [.fps]
        call    wt2f64

        invoke  IsDlgButtonChecked, [Dialog], IDC_RB_FCOUNT
        cmp     eax, BST_CHECKED
        je     .gb.ftime
    .gb.fcount:
        ; get hours
        mov     eax, [ed.hours]
        lea     edi, [.hours]
        call    wt2f64

        ; get minutes
        mov     eax, [ed.minutes]
        lea     edi, [.mins]
        call    wt2f64

        ; get seconds
        mov     eax, [ed.seconds]
        lea     edi, [.secs]
        call    wt2f64

        fld     qword [.secs]
        fld     qword [.mins]
        fimul   word [i60]
        fld     qword [.hours]
        fimul   word [i3600]
        faddp
        faddp
        fld     st0
        fstp    qword [.ftimes]
        ; frame count = time * fps
        fld     qword [.fps]
        fmulp
        fld     st0
        fstp    qword [.fcount]
        ; print frame count
        st2wt0  [ed.fcount]
        jmp    .gb.delta
    .gb.ftime:
        ; get frame count
        mov     eax, [ed.fcount]
        lea     edi, [.fcount]
        call    wt2f64

        fld     qword [.fcount]
        fld     qword [.fps]
        fdivp   ; st0 = film length in seconds
        fld     st0
        fld     st0
        fstp    qword [.ftimes] ; film length in seconds
        ; hours
        fidiv   word [i3600]
        call    st0int ; st0 = hours
        fld     st0
        ; print hours
        st2wt0  [ed.hours]
        fimul   word [i3600]
        fsubp
        fld     st0
        ; minutes
        fidiv   word [i60]
        call    st0int ; st0 = minutes
        fld     st0
        ; print minutes
        st2wt0  [ed.minutes]
        fimul   word [i60]
        fsubp
        ; print seconds
        st2wt3  [ed.seconds]

    .gb.delta:
        mov     ebx, a1.controls
        lea     edx, [.delta1]
        call   .ProcessAudio

        mov     ebx, a2.controls
        lea     edx, [.delta2]
        call   .ProcessAudio

    .gb.frover:
        ; frame overhead = ffactor * frames
        invoke  SendMessage, [ch.frover], BM_GETCHECK, 0, 0
        cmp     eax, BST_CHECKED
        je     .gb.frover.get
        fldz
        jmp    .gb.frover.set
    .gb.frover.get:
        fld     dword [fof]
        fmul    qword [.fcount]
    .gb.frover.set:
        fstp    qword [.frover]

    .gb.get.bitrate:
        fld     qword [.cdsize]
        cmp     [SizeEdit], 1
        je      @F
        fmul    qword [.sizem]
        fdiv    qword [.sized]
        fst     qword [.cdsize]
    @@:

        fsub    qword [.delta1]
        fsub    qword [.delta2]
        fsub    qword [.frover]
        fmul    dword [f1024d125]
        fdiv    qword [.ftimes]

    .gb.bitrate.verify:
        sub     esp, 8
        fst     qword [esp]
        mov     dx, word [esp + 6]
        add     esp, 8
        and     dx, 0x7FF0
        cmp     dx, 0x7FF0
        je     .gb.bitrate.error.fpu
        fcom    qword [BitrateFloor]
        fnjl   .gb.bitrate.error.floor
        fcom    qword [BitrateCeil]
        fnjg   .gb.bitrate.error.ceil
    .gb.bitrate.success:
        ; standard presicion on valid result
        mov     al, '3'
        mov     [BitrateColor], BIC_COLOR_SUCCESS
        jmp    .gb.bitrate.print
    .gb.bitrate.error.ceil:
    .gb.bitrate.error.floor:
        mov     al, '0'
        mov     [BitrateColor], BIC_COLOR_ERROR
        jmp    .gb.bitrate.print
    .gb.bitrate.error.fpu:
        ; change presicion to print special results
        ; -----------------------------------------
        ;  + Infinity  |      1.#INF              |
        ;   Infinity  |     1.#INF              |
        ;  Indefinite  |  digit.#IND              |
        ;  NaN         |  digit.#NAN              |
        ; -----------------------------------------
        mov     al, '4'
        mov     [BitrateColor], BIC_COLOR_ERROR
    .gb.bitrate.print:
        mov     edi, [ed.vbitrate]
        mov     [LockEdit], edi
        call    st2wt
        mov     [LockEdit], 0
    .gb.bitrate.verify.leave:

        cmp     [SizeEdit], 1
        je     .gb.cdsize.verify.leave
    .gb.cdsize.verify:
        fld     qword [.cdsize]
        sub     esp, 8
        fst     qword [esp]
        mov     dx, word [esp + 6]
        add     esp, 8
        and     dx, 0x7FF0
        cmp     dx, 0x7FF0
        je     .gb.cdsize.error.fpu
    .gb.cdsize.success:
        ; standard presicion on valid result
        mov     al, '3'
        mov     [CDSizeColor], BIC_COLOR_SUCCESS
        jmp    .gb.cdsize.print
    .gb.cdsize.error.fpu:
        ; change presicion to print special results
        ; -----------------------------------------
        ;  + Infinity  |      1.#INF              |
        ;   Infinity  |     1.#INF              |
        ;  Indefinite  |  digit.#IND              |
        ;  NaN         |  digit.#NAN              |
        ; -----------------------------------------
        mov     al, '4'
        mov     [CDSizeColor], BIC_COLOR_ERROR
    .gb.cdsize.print:
        mov     edi, [ed.cdsize]
        mov     [LockEdit], edi
        call    st2wt
        mov     [LockEdit], 0
    .gb.cdsize.verify.leave:

    .gb.return:
        ; clear all exceptions
        fnclex
        pop     edi esi ebx
        ret

$sproc .ProcessAudio
        ; -> edx - offset of [delta] variable
        ; -> ebx - [audio controls array] offset
        ; ebx + 00 = audio track count COMBOBOX
        ; ebx + 06 = audio format COMBOBOX
        ; ebx + 12 = audio bitrate COMBOBOX
        ; ebx + 18 = audio track size EDIT
        ; ebx + 24 = audio track size RADIOBUTTON ID
        ; ebx + 28 = audio track size RADIOBUTTON IDC
        ; ebx + 30 = audio interleave frame count COMBOBOX
        ; ebx + 36 = audio interleave interval STATICTEXT
    .pa.enter:
        push    edx ; save delta offset

        ; audio format
        invoke  SendMessage, [ebx + 6], CB_GETCURSEL, 0, 0
        mov     edi, eax
        mov     [.aformat], eax
        cmp     eax, 1
        jne     @F
        invoke  SetWindowText, [ebx + 30], iframes.01
    @@:
        dec     edi
        invoke  EnableWindow, [ebx + 30], edi

        ; audio interleave frame count
        invoke  GetWindowText, [ebx + 30], esi, .bsize
        test    eax, eax
        je      @F
        cinvoke atoi, esi
    @@: mov     [.iframes], eax
        ; print audio interleave interval in ms
        sub     esp, 8
        fild    dword [.iframes]
        fimul   word [i1000]
        fdiv    qword [.fps]
        fstp    qword [esp]
        cinvoke vsprintf, esi, sffmt.iims, esp
        invoke  SetWindowText, [ebx + 36], esi
        add     esp, 8

        ; audio track count
        invoke  GetWindowText, [ebx], esi, .bsize
        test    eax, eax
        je      @F
        cinvoke atoi, esi
    @@: mov     [.tcount], eax ; save track count
        test    eax, eax
        jz     .pa.ohskip

    .pa.overhead:
        ; audio overhead = (afactor * tracks / iframes) * frames
        mov     eax, [.aformat]
        fld     dword [aof + eax * 4]
        fimul   dword [.tcount]
        fidiv   dword [.iframes]
        fmul    qword [.fcount]
        jmp    .pa.audiosize
    .pa.ohskip:
        fldz    ; overhead = 0

    .pa.audiosize:
        movzx   eax, word [ebx + 28]
        invoke  IsDlgButtonChecked, [Dialog], eax
        cmp     eax, BST_CHECKED
        je     .pa.tbitrate
    .pa.tsize:
        ; audio track size = bitrate * time * 125 / (8 * 128) = bitrate * time * 0.1220703125
        mov     eax, [ebx + 12]
        lea     edi, [.abrate]
        call    wt2f64
        fld     qword [.abrate]
        fld     qword [.ftimes]
        fmulp
        fld     dword [f125d1024]
        fmulp
        fld     st0
        fstp    qword [.tsize] ; single track size
        ; print audio track size
        st2wt3  [ebx + 18]
        jmp    .pa.delta
    .pa.tbitrate:
        ; audio bitate = [track size] * (8 * 128) / (time * 125) = [track size] * 8.192 / time
        mov     eax, [ebx + 18]
        lea     edi, [.tsize]
        call    wt2f64
        fld     qword [.tsize]
        fld     dword [f1024d125]
        fmulp
        fld     qword [.ftimes]
        fdivp   ; st0 = bitrate
        ; print audio bitrate
        st2wt3  [ebx + 12]

    .pa.delta:
        fld     qword [.tsize]
        fimul   dword [.tcount] ; st0 = audio size = [track count] * [track size]
                                ; st1 = overhead
        faddp                   ; delta = audio size + overhead
        pop     edx             ; restore delta offset
        fstp    qword [edx]

    .pa.return:
        ; clear all exceptions
        fnclex
        retn
$endp

$endp

; ------------------------------------------------------------------------------

; select file & [hwnd].text <- file size (in KB)
$proc SelectFile, hwnd

       $locals
       .bsize   = 512
       .buffer  rb .bsize
       .ofn     OPENFILENAME
       .ffd     WIN32_FIND_DATA
       $end

    .sf.enter:
        push    esi edi

    .sf.openfn:
        mov     [.buffer], byte 0

        ; zero ofn structure
        cld
        lea     edi, [.ofn]
        mov     ecx, sizeof.OPENFILENAME
        xor     eax, eax
        rep     stosb

        mov     [.ofn.lStructSize], sizeof.OPENFILENAME
        mov     eax, [Dialog]
        mov     [.ofn.hwndOwner], eax
        mov     [.ofn.lpstrFilter], ofnFilter
        lea     eax, [.buffer]
        mov     [.ofn.lpstrFile], eax
        mov     [.ofn.nMaxFile], .bsize
        mov     [.ofn.Flags], OFN_FILEMUSTEXIST + OFN_LONGNAMES + OFN_EXPLORER
        mov     [.ofn.lpstrTitle], ofnTitle
        lea     edi, [.ofn]
        invoke  GetOpenFileName, edi
        test    eax, eax
        je     .sf.return

    .sf.getfilesize:
        lea     edi, [.ffd]
        invoke  FindFirstFile, [.ofn.lpstrFile], edi
        cmp     eax, INVALID_HANDLE_VALUE
        je     .sf.return
        invoke  FindClose, eax
        fild    dword [.ffd.nFileSizeLow]
        fidiv   word [i1024]
        ; print file size
        lea     esi, [.buffer]
        st2wt3  [hwnd]

    .sf.return:
        pop     edi esi
        ret
$endp

; ------------------------------------------------------------------------------

include 'BICU.ASM'
include 'INCLUDE\FLOAT.ASM'

; ------------------------------------------------------------------------------

Instance            dd ?
OrgEditProc         dd ? ; original edit window proc

Dialog              dd ?
SysMenu             dd ?
BoldFont            dd ?
LockEdit            dd 0
SizeEdit            dd 0

BIC_COLOR_SUCCESS   = 0x00C00000
BIC_COLOR_ERROR     = 0x000000F0

BitrateColor        dd BIC_COLOR_SUCCESS
BitrateFloor        dq 00000.0
BitrateCeil         dq 64000.0
CDSizeColor         dd BIC_COLOR_SUCCESS

; ------------------------------------------------------------------------------

controls:           ; controls

cb.cdsize           dd ?
cb.cdsize.idc       dw IDC_CB_CDSIZE
cb.cdsize.mul       dd ?
cb.cdsize.mul.idc   dw IDC_CB_CDSIZE_MUL
cb.cdsize.div       dd ?
cb.cdsize.div.idc   dw IDC_CB_CDSIZE_DIV
ed.cdsize           dd ?
ed.cdsize.idc       dw IDC_ED_CBSIZE

bold.controls:      ; bold controls

st.vbitrate         dd ?
st.vbitrate.idc     dw IDC_ST_VBITRATE
ed.vbitrate         dd ?
ed.vbitrate.idc     dw IDC_ED_VBITRATE
gb.video            dd ?
gb.video.idc        dw IDC_GB_VIDEO
gb.audio2           dd ?
gb.audio2.idc       dw IDC_GB_AUDIO2
gb.audio1           dd ?
gb.audio1.idc       dw IDC_GB_AUDIO1
gb.a2.inter         dd ?
gb.a2.inter.idc     dw IDC_GB_A2_INTERLEAVE
gb.a1.inter         dd ?
gb.a1.inter.idc     dw IDC_GB_A1_INTERLEAVE

bold.controls.count = ($ - bold.controls) / 6

cb.fps              dd ?
cb.fps.idc          dw IDC_CB_FPS
ed.hours            dd ?
ed.hours.idc        dw IDC_ED_HOURS
ed.minutes          dd ?
ed.minutes.idc      dw IDC_ED_MINUTES
ed.seconds          dd ?
ed.seconds.idc      dw IDC_ED_SECONDS
ed.fcount           dd ?
ed.fcount.idc       dw IDC_ED_FCOUNT

a1.controls:        ; audio A controls

cb.a1.tcount        dd ?                       ; + 00 = audio track count COMBOBOX
cb.a1.tcount.idc    dw IDC_CB_A1_TCOUNT
cb.a1.format        dd ?                       ; + 06 = audio format COMBOBOX
cb.a1.format.idc    dw IDC_CB_A1_FORMAT
cb.a1.bitrate       dd ?                       ; + 12 = audio bitrate COMBOBOX
cb.a1.bitrate.idc   dw IDC_CB_A1_BITRATE
ed.a1.tsize         dd ?                       ; + 18 = audio track size EDIT
ed.a1.tsize.idc     dw IDC_ED_A1_TSIZE
rb.a1.tsize         dd ?                       ; + 24 = audio track size RADIOBUTTON
rb.a1.tsize.idc     dw IDC_RB_A1_TSIZE         ; + 28 = audio track size RADIOBUTTON IDC
cb.a1.iframes       dd ?                       ; + 30 = audio interleave frame count COMBOBOX
cb.a1.iframes.idc   dw IDC_CB_A1_IFRAMES
st.a1.iinterval     dd ?                       ; + 36 = audio interleave interval STATICTEXT
st.a1.iinterval.idc dw IDC_ST_A1_IINTERVAL

a1.controls.count   = ($ - a1.controls) / 6

a2.controls:        ; audio B controls

cb.a2.tcount        dd ?                       ; + 00 = audio track count COMBOBOX
cb.a2.tcount.idc    dw IDC_CB_A2_TCOUNT
cb.a2.format        dd ?                       ; + 06 = audio format COMBOBOX
cb.a2.format.idc    dw IDC_CB_A2_FORMAT
cb.a2.bitrate       dd ?                       ; + 12 = audio bitrate COMBOBOX
cb.a2.bitrate.idc   dw IDC_CB_A2_BITRATE
ed.a2.tsize         dd ?                       ; + 18 = audio track size EDIT
ed.a2.tsize.idc     dw IDC_ED_A2_TSIZE
rb.a2.tsize         dd ?                       ; + 24 = audio track size RADIOBUTTON
rb.a2.tsize.idc     dw IDC_RB_A2_TSIZE         ; + 28 = audio track size RADIOBUTTON IDC
cb.a2.iframes       dd ?                       ; + 30 = audio interleave frame count COMBOBOX
cb.a2.iframes.idc   dw IDC_CB_A2_IFRAMES
st.a2.iinterval     dd ?                       ; + 36 = audio interleave interval STATICTEXT
st.a2.iinterval.idc dw IDC_ST_A2_IINTERVAL

a2.controls.count   = ($ - a2.controls) / 6

ch.frover           dd ?                       ; frame overhead CHECKBOX
ch.frover.idc       dw IDC_CH_FROVER

controls.count      = ($ - controls) / 6

; ------------------------------------------------------------------------------

;                   dd 0.015625     ; 16 / 1024
;                   dd 0.01953125   ; 20 / 1024
;                   dd 0.0234375    ; 24 / 1024
;                   dd 0.02734375   ; 28 / 1024
;                   dd 0.03125      ; 32 / 1024
;                   dd 0.03515625   ; 36 / 1024
;                   dd 0.0390625    ; 40 / 1024
;                   dd 0.04296875   ; 44 / 1024
;                   dd 0.046875     ; 48 / 1024
;                   dd 0.05078125   ; 52 / 1024
;                   dd 0.0546875    ; 56 / 1024
;                   dd 0.05859375   ; 60 / 1024
;                   dd 0.0625       ; 64 / 1024
;                   dd 0.06640625   ; 68 / 1024
;                   dd 0.0703125    ; 72 / 1024

; audio overhead factors
aof:
aof.cbr             dd 0.0234375    ; 24 / 1024
aof.vbr             dd 0.03515625   ; 36 / 1024
aof.ac3             dd 0.0234375    ; 24 / 1024

; frame overhead factor
fof:                dd 0.0234375    ; 24 / 1024

; ------------------------------------------------------------------------------

f125d1024           dd 0.1220703125 ; 125 / 1024
f1024d125           dd 8.192        ; 1024 / 125

i60                 dw 60
i1000               dw 1000
i1024               dw 1024         ; = 8 * 128
i3600               dw 3600

sffmt.0f            db '%.0f',0
sffmt.iims          db '%.0f ms',0
; sffmt.KB          db '%.0f  KB',0

sTahoma             db 'Tahoma',0

sXVID               db 'X V I D ',0
sDIVX               db 'D I V X ',0
sCAPTION            db 'X V I D  Bitrate Calculator',0

ofnTitle            db 'Select audio file',0

ofnFilter           db 'Wav file (*.wav)',0,'*.wav',0,\
                       'MP3 file (*.mp3)',0,'*.mp3',0,\
                       'AC3 file (*.ac3)',0,'*.ac3',0,\
                       'Audio file (*.wav *.mp3 *.ac3)',0,'*.wav;*.mp3;*.ac3',0,\
                       'Any file (*.*)',0,'*.*',0,0

; ------------------------------------------------------------------------------

; D5 = 4700000000 bytes = 4589843.75 KB

fstrtab cdsize,\
        CD    , '  716800       1 CD' ,\ ; 700 MB
        CDx2  , '1433600       2 CD'  ,\ ; 700 MB * 2
        D5    , '4589843.7    D5'     ,\ ; DVD5     = 4589843.75
        D5D2  , '2294921.8    D5/2'   ,\ ; DVD5 / 2 = 2294921.875
        D5D3  , '1529947.9    D5/3'   ,\ ; DVD5 / 3 = 1529947.91(6)
        D5D4  , '1147400.9    D5/4'   ,\ ; DVD5 / 4 = 1147460.9375
        D5D5  , '  917968.7    D5/5'  ,\ ; DVD5 / 5 = 917968.75
        D5D6  , '  764973.9    D5/6'     ; DVD5 / 6 = 764973.958(3)

; fstrtab cdsize,\
;        CD    , '  716800    1 CD'  ,\ ; 700 MB
;        CDx2  , '1433600    2 CD'   ,\ ; 700 MB * 2
;        D5    , '4589800    1 D5'   ,\ ; DVD5
;        D5D2  , '2294900    D5/2'   ,\ ; DVD5 / 2
;        D5D3  , '1529900    D5/3'   ,\ ; DVD5 / 3
;        D5D4  , '1147400    D5/4'   ,\ ; DVD5 / 4
;        D5D5  , '  917900    D5/5'  ,\ ; DVD5 / 5
;        D5D6  , '  764900    D5/6'     ; DVD5 / 6

fstrtab cdsize.mul,\
        01 , '1' ,\
        02 , '2' ,\
        03 , '3' ,\
        04 , '4' ,\
        05 , '5' ,\
        06 , '6' ,\
        07 , '7' ,\
        08 , '8' ,\
        09 , '9'

fstrtab cdsize.div,\
        01 , '1' ,\
        02 , '2' ,\
        03 , '3' ,\
        04 , '4' ,\
        05 , '5' ,\
        06 , '6' ,\
        07 , '7' ,\
        08 , '8' ,\
        09 , '9'

fstrtab fps,\
        15.000, '15.000',\
        20.000, '20.000',\
        23.976, '23.976',\
        23.978, '23.978',\
        23.980, '23.980',\
        24.000, '24.000',\
        24.975, '24.975',\
        25.000, '25.000',\
        29.970, '29.970',\
        29.971, '29.971',\
        30.000, '30.000',\
        50.000, '50.000',\
        59.940, '59.940',\
        60.000, '60.000'

fstrtab atcount,\
        00, '0',\
        01, '1',\
        02, '2'

fstrtab aformat,\
        cbr, ' MP3-CBR',\
        vbr, ' MP3-VBR',\
        ac3, ' AC3'

fstrtab abitrate,\
        032, '32',\
        056, '56',\
        064, '64',\
        096, '96',\
        112, '112',\
        128, '128',\
        160, '160',\
        192, '192',\
        224, '224',\
        256, '256',\
        320, '320',\
        384, '384',\
        448, '448',\
        512, '512'

fstrtab iframes,\
        01, '1',\
        24, '24',\
        25, '25',\
        30, '30'

; ------------------------------------------------------------------------------

section '.idata' import data readable writeable

library kernel32,'KERNEL32.DLL',\
        user32,'USER32.DLL',\
        gdi32,'GDI32.DLL',\
        comdlg32,'COMDLG32.DLL',\
        msvcrt,'MSVCRT.DLL'

import  kernel32,\
        LoadLibrary,'LoadLibraryA',\
        GetProcAddress,'GetProcAddress',\
        GetModuleHandle,'GetModuleHandleA',\
        FindFirstFile,'FindFirstFileA',\
        FindClose,'FindClose',\
        ExitProcess,'ExitProcess'

import  user32,\
        DefWindowProc,'DefWindowProcA',\
        DialogBoxParam,'DialogBoxParamA',\
        LoadIcon, 'LoadIconA',\
        SendMessage,'SendMessageA',\
        PostMessage,'PostMessageA',\
        SendDlgItemMessage,'SendDlgItemMessageA',\
        GetDlgItem,'GetDlgItem',\
        GetSysColorBrush,'GetSysColorBrush',\
        GetDC,'GetDC',\
        ReleaseDC,'ReleaseDC',\
        CheckRadioButton,'CheckRadioButton',\
        IsDlgButtonChecked,'IsDlgButtonChecked',\
        UpdateWindow,'UpdateWindow',\
        GetWindowText,'GetWindowTextA',\
        SetWindowText,'SetWindowTextA',\
        GetFocus,'GetFocus',\
        SetFocus,'SetFocus',\
        EnableWindow,'EnableWindow',\
        GetClassLong,'GetClassLongA',\
        SetClassLong,'SetClassLongA',\
        GetWindowLong,'GetWindowLongA',\
        SetWindowLong,'SetWindowLongA',\
        CallWindowProc,'CallWindowProcA',\
        GetSystemMenu,'GetSystemMenu',\
        InsertMenuItem,'InsertMenuItemA',\
        SetMenuDefaultItem,'SetMenuDefaultItem',\
        GetMenuState,'GetMenuState',\
        DrawMenuBar,'DrawMenuBar',\
        CheckMenuItem,'CheckMenuItem',\
        GetKeyState,'GetKeyState',\
        EndDialog,'EndDialog'

import  gdi32,\
        CreateFont,'CreateFontA',\
        CreateFontIndirect,'CreateFontIndirectA',\
        SetTextColor,'SetTextColor',\
        SetBkMode,'SetBkMode',\
        GetStockObject,'GetStockObject',\
        GetObject,'GetObjectA',\
        GetCurrentObject,'GetCurrentObject',\
        DeleteObject,'DeleteObject'

import  comdlg32,\
        GetOpenFileName,'GetOpenFileNameA'

import  msvcrt,\
        atoi,'atoi',\
        atof,'atof',\
        vsprintf,'vsprintf',\
        sprintf,'sprintf'

; ------------------------------------------------------------------------------

section '.rsrc' resource data readable

TEXT_ED_HOURS           equ '1'
TEXT_ED_MINUTES         equ '30'
TEXT_ED_SECONDS         equ '0.000'
TEXT_ED_FCOUNT          equ '135000'

IDD_MAINDLG             = 101
IDI_MAINICON            = 201

IDC_ST_CDSIZE           = 1001
IDC_CB_CDSIZE           = 1002
IDC_ST_CDSIZE_MUL       = 1003
IDC_CB_CDSIZE_MUL       = 1004
IDC_ST_CDSIZE_DIV       = 1005
IDC_CB_CDSIZE_DIV       = 1006
IDC_ED_CBSIZE           = 1007
IDC_ST_VBITRATE         = 1008
IDC_ED_VBITRATE         = 1009

IDC_GB_VIDEO            = 1101
IDC_ST_VIDEO            = 1102
IDC_ST_FPS              = 1103
IDC_CB_FPS              = 1104
IDC_RB_FLENGTH          = 1105
IDC_RB_FCOUNT           = 1106
IDC_ST_HOURS            = 1107
IDC_ED_HOURS            = 1108
IDC_ST_MINUTES          = 1109
IDC_ED_MINUTES          = 1110
IDC_ST_SECONDS          = 1111
IDC_ED_SECONDS          = 1112
IDC_ED_FCOUNT           = 1113

IDC_GB_AUDIO1           = 1201
IDC_ST_AUDIO1           = 1202
IDC_ST_A1_TCOUNT        = 1203
IDC_CB_A1_TCOUNT        = 1204
IDC_ST_A1_FORMAT        = 1205
IDC_CB_A1_FORMAT        = 1206
IDC_RB_A1_BITRATE       = 1207
IDC_RB_A1_TSIZE         = 1208
IDC_CB_A1_BITRATE       = 1209
IDC_ED_A1_TSIZE         = 1210

IDC_GB_A1_INTERLEAVE    = 1211
IDC_ST_A1_INTERLEAVE    = 1212
IDC_ST_A1_IFRAMES       = 1213
IDC_CB_A1_IFRAMES       = 1214
IDC_ST_A1_IINTERVAL     = 1215

IDC_GB_AUDIO2           = 1221
IDC_ST_AUDIO2           = 1222
IDC_ST_A2_TCOUNT        = 1223
IDC_CB_A2_TCOUNT        = 1224
IDC_ST_A2_FORMAT        = 1225
IDC_CB_A2_FORMAT        = 1226
IDC_RB_A2_BITRATE       = 1227
IDC_RB_A2_TSIZE         = 1228
IDC_CB_A2_BITRATE       = 1229
IDC_ED_A2_TSIZE         = 1230

IDC_GB_A2_INTERLEAVE    = 1231
IDC_ST_A2_INTERLEAVE    = 1232
IDC_ST_A2_IFRAMES       = 1233
IDC_CB_A2_IFRAMES       = 1234
IDC_ST_A2_IINTERVAL     = 1235

IDC_CH_FROVER           = 1241
IDC_BT_CLOSE            = 1242

WSTYLE                  = WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + WS_MINIMIZEBOX + WS_VISIBLE + DS_CENTER
CSTYLE_BASE             = WS_CHILD + WS_VISIBLE
CSTYLE_BASE_TS          = WS_CHILD + WS_VISIBLE + WS_TABSTOP
CSTYLE_ST               = CSTYLE_BASE
CSTYLE_GB               = CSTYLE_BASE + BS_GROUPBOX
CSTYLE_RB               = CSTYLE_BASE_TS + BS_AUTORADIOBUTTON
CSTYLE_RB_GR            = CSTYLE_RB + WS_GROUP

CSTYLE_ED               = CSTYLE_BASE_TS
CSTYLE_ED_RO            = CSTYLE_BASE_TS + ES_READONLY
CSTYLE_ED_DA            = CSTYLE_BASE_TS + WS_DISABLED
CSTYLE_ED_NUM           = CSTYLE_BASE_TS + ES_NUMBER
CSTYLE_ED_NUM_DA        = CSTYLE_BASE_TS + WS_DISABLED + ES_NUMBER

CSTYLE_ED_H             = CSTYLE_ED_NUM_DA ; hours EDIT style
CSTYLE_ED_M             = CSTYLE_ED_NUM_DA ; minutes EDIT style
CSTYLE_ED_S             = CSTYLE_ED_DA     ; seconds EDIT style
CSTYLE_ED_FC            = CSTYLE_ED_NUM    ; frame count EDIT style

CSTYLE_EX_ED            = WS_EX_CLIENTEDGE
CSTYLE_CB_BASE          = CSTYLE_BASE_TS + WS_VSCROLL
CSTYLE_CB               = CSTYLE_CB_BASE + CBS_DROPDOWN
CSTYLE_CB_LIST          = CSTYLE_CB_BASE + CBS_DROPDOWNLIST
CSTYLE_CH               = CSTYLE_BASE_TS + BS_AUTOCHECKBOX
CSTYLE_BT               = CSTYLE_BASE_TS

directory \
    RT_ICON, icons,\
    RT_GROUP_ICON, group_icons,\
    RT_DIALOG, dialogs,\
    RT_VERSION, r_version_info,\
    RT_MANIFEST, r_manifest

resource icons,\
         1, LANG_NEUTRAL, icon_data

resource group_icons,\
         IDI_MAINICON, LANG_NEUTRAL, main_icon

resource dialogs,\
         IDD_MAINDLG, LANG_NEUTRAL, demonstration

resource r_version_info,\
         1, LANG_NEUTRAL, version_info

resource r_manifest,\
         1, LANG_NEUTRAL, manifest

icon main_icon,\
     icon_data, 'i.ico'

TOP_SHIFT = 20

dialog demonstration, '', 0, 0, 236, 256 + TOP_SHIFT, WSTYLE, 0, 0, 'Tahoma', 8
    dialogitem 'BUTTON', 'Video', IDC_GB_VIDEO,\
               4, 24 + TOP_SHIFT, 228, 75, CSTYLE_GB
    dialogitem 'BUTTON', 'Audio B', IDC_GB_AUDIO2,\
               118, 96 + TOP_SHIFT, 114, 95, CSTYLE_GB
    dialogitem 'BUTTON', 'Audio A', IDC_GB_AUDIO1,\
               4, 96 + TOP_SHIFT, 113, 95, CSTYLE_GB
    dialogitem 'BUTTON', 'Audio B  Interleaving', IDC_GB_A2_INTERLEAVE,\
               118, 188 + TOP_SHIFT, 114, 43, CSTYLE_GB
    dialogitem 'BUTTON', 'Audio A  Interleaving', IDC_GB_A1_INTERLEAVE,\
               4, 188 + TOP_SHIFT, 113, 43, CSTYLE_GB

    dialogitem 'STATIC', 'Target size (KB)', IDC_ST_CDSIZE,\
               10, 8, 64, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_CDSIZE,\
               66, 6, 78, 80, CSTYLE_CB
    dialogitem 'STATIC', '*', IDC_ST_CDSIZE_MUL,\
               147, 8, 8, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_CDSIZE_MUL,\
               154, 6, 32, 80, CSTYLE_CB
    dialogitem 'STATIC', '/', IDC_ST_CDSIZE_DIV,\
               190, 8, 8, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_CDSIZE_DIV,\
               196, 6, 32, 80, CSTYLE_CB
    dialogitem 'STATIC', 'Bitrate = ', IDC_ST_VBITRATE,\
               10, 24, 36, 9, CSTYLE_ST
    dialogitem 'EDIT', '', IDC_ED_VBITRATE,\
               46, 24, 98, 13, CSTYLE_ED_RO
    dialogitem 'EDIT', '', IDC_ED_CBSIZE,\
               154, 22, 74, 13, CSTYLE_ED, CSTYLE_EX_ED

    dialogitem 'BUTTON', 'Duration', IDC_RB_FLENGTH,\
               20, 42 + TOP_SHIFT, 40, 11, CSTYLE_RB_GR
    dialogitem 'BUTTON', 'Frames', IDC_RB_FCOUNT,\
               20, 58 + TOP_SHIFT, 40, 11, CSTYLE_RB
    dialogitem 'STATIC', 'hours', IDC_ST_HOURS,\
               75, 32 + TOP_SHIFT, 24, 9, CSTYLE_ST
    dialogitem 'EDIT', TEXT_ED_HOURS, IDC_ED_HOURS,\
               70, 42 + TOP_SHIFT, 28, 13, CSTYLE_ED_H, CSTYLE_EX_ED
    dialogitem 'STATIC', 'minutes', IDC_ST_MINUTES,\
               102, 32 + TOP_SHIFT, 32, 9, CSTYLE_ST
    dialogitem 'EDIT', TEXT_ED_MINUTES, IDC_ED_MINUTES,\
               100, 42 + TOP_SHIFT, 28, 13, CSTYLE_ED_M, CSTYLE_EX_ED
    dialogitem 'STATIC', 'seconds', IDC_ST_SECONDS,\
               139, 32 + TOP_SHIFT, 40, 9, CSTYLE_ST
    dialogitem 'EDIT', TEXT_ED_SECONDS, IDC_ED_SECONDS,\
               130, 42 + TOP_SHIFT, 46, 13, CSTYLE_ED_S, CSTYLE_EX_ED
    dialogitem 'EDIT', TEXT_ED_FCOUNT, IDC_ED_FCOUNT,\
               70, 58 + TOP_SHIFT, 58, 13, CSTYLE_ED_FC, CSTYLE_EX_ED
    dialogitem 'STATIC', 'Frames per second', IDC_ST_FPS,\
               134, 76 + TOP_SHIFT, 62, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_FPS,\
               70, 74 + TOP_SHIFT, 58, 80, CSTYLE_CB

    dialogitem 'STATIC', 'Tracks', IDC_ST_A1_TCOUNT,\
               12, 110 + TOP_SHIFT, 24, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A1_TCOUNT,\
               44, 108 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'STATIC', 'Format', IDC_ST_A1_FORMAT,\
               12, 126 + TOP_SHIFT, 22, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A1_FORMAT,\
               44, 124 + TOP_SHIFT, 64, 80, CSTYLE_CB_LIST
    dialogitem 'BUTTON', 'kbps', IDC_RB_A1_BITRATE,\
               10, 150 + TOP_SHIFT, 30, 11, CSTYLE_RB_GR
    dialogitem 'BUTTON', 'KB', IDC_RB_A1_TSIZE,\
               10, 166 + TOP_SHIFT, 24, 11, CSTYLE_RB
    dialogitem 'COMBOBOX', '', IDC_CB_A1_BITRATE,\
               44, 150 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'EDIT', '', IDC_ED_A1_TSIZE,\
               44, 166 + TOP_SHIFT, 64, 13, CSTYLE_ED_DA, CSTYLE_EX_ED

    dialogitem 'STATIC', 'Frames', IDC_ST_A1_IFRAMES,\
               12, 202 + TOP_SHIFT, 26, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A1_IFRAMES,\
               44, 200 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'STATIC', '0 ms', IDC_ST_A1_IINTERVAL,\
               44, 216 + TOP_SHIFT, 64, 9, CSTYLE_ST

    dialogitem 'STATIC', 'Tracks', IDC_ST_A2_TCOUNT,\
               126, 110 + TOP_SHIFT, 24, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A2_TCOUNT,\
               158, 108 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'STATIC', 'Format', IDC_ST_A2_FORMAT,\
               126, 126 + TOP_SHIFT, 22, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A2_FORMAT,\
               158, 124 + TOP_SHIFT, 64, 80, CSTYLE_CB_LIST
    dialogitem 'BUTTON', 'kbps', IDC_RB_A2_BITRATE,\
               124, 150 + TOP_SHIFT, 30, 11, CSTYLE_RB_GR
    dialogitem 'BUTTON', 'KB', IDC_RB_A2_TSIZE,\
               124, 166 + TOP_SHIFT, 24, 11, CSTYLE_RB
    dialogitem 'COMBOBOX', '', IDC_CB_A2_BITRATE,\
               158, 150 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'EDIT', '', IDC_ED_A2_TSIZE,\
               158, 166 + TOP_SHIFT, 64, 13, CSTYLE_ED_DA, CSTYLE_EX_ED

    dialogitem 'STATIC', 'Frames', IDC_ST_A2_IFRAMES,\
               126, 202 + TOP_SHIFT, 26, 9, CSTYLE_ST
    dialogitem 'COMBOBOX', '', IDC_CB_A2_IFRAMES,\
               158, 200 + TOP_SHIFT, 64, 80, CSTYLE_CB
    dialogitem 'STATIC', '0 ms', IDC_ST_A2_IINTERVAL,\
               158, 216 + TOP_SHIFT, 64, 9, CSTYLE_ST

    dialogitem 'BUTTON', 'Frame overhead', IDC_CH_FROVER,\
               12, 238 + TOP_SHIFT, 68, 8, CSTYLE_CH

    dialogitem 'BUTTON', 'Close', IDC_BT_CLOSE,\
               178, 236 + TOP_SHIFT, 52, 15, CSTYLE_BT
enddialog

versioninfo version_info,\
    VOS__WINDOWS32, VFT_APP, VFT2_UNKNOWN, LANG_NEUTRAL, 0,\
    'FileDescription', RS_Description,\
    'FileVersion', RS_Version,\
    'CompanyName', RS_Email

resdata manifest
    file 'manifest.xml'
endres

; ------------------------------------------------------------------------------
